# Réunion 12

**Date et heure.** 2 février 2019 à 10h00

**Prochaine réunion.** 8 février 2019 à 14h00

**Ordre du jour.**

1.  TDS
1.  Contrôles sémantiques
1.  Travail à faire

## 1. TDS

Comme prévu, la branche `dev` a été abandonnée et on travaille sur la branche `dev2`. Dessus, on a ajouté les espaces de noms avec la classe `Namespace` qui est nouvelle. Tristan a réimplémenté la table des symboles d'ordre zéro. Il s'est aussi surtout occupé du `let`. Il s'est occupé de la définition des types et des variables, a géré la récursivité des fonctions.

Tristan a géré des tables des symboles intermédiaires dans les `let`. Il peut y avoir plusieurs tables des symboles dans un `let`. En effet, on peut déclarer plusieurs fois la même fonction dans un même bloc `let`, mais certaines variables, fonctions ou types entre ces variables

```tiger
function f() : int = 1
let x : int = f()
function f() : int = 0
```

Il ne reste rien à faire à part l'initialisation des variables. Pour l'instant, tout ce qui est déclaré est dans la table, type et fonctions. Au niveau de la TDS, il ne reste donc que l'initialisation des variables.

Philippe propose de parler de `fillWithFor`.  C'est David qui a écrit le corps de cette fonction.

## 2. Contrôles sémantiques

Des contrôles sémantiques ont été effectués sur `SEQ`, `CALL` et les opérateurs.

David a effectué quelques contrôles sémantiques : ils sont tous réunis au niveau du `fillWith`. Elle concerne tout ce qui est opérateur.  Il propose aussi de réunir tous les contrôles sémantiques dans un documents. On n'a pas à gérer les `Alias` dans les contrôles de type.

David explique comment fonctionne le `Notifier`.

On remet à plus tard la coloration sémantique des erreurs. Tristan propose d'écrire toutes les erreurs en anglais.

Tristan remarque que plusieurs erreurs sémantiques qui n'ont pas encore été évoqués. Ils sont sur `Issues` dans Discord. David demande à Tristan de mettre ces contrôles sémantiques dans le fichier concerné.

Ce qu'il reste à faire dans les contrôles sémantiques.

-   Vérifier que l'on affecte pas l'indice d'une boucle dans une boucle
-   Ce qui est à gauche d'une affectation est une l-value
-   Inférence des types lors de la déclaration d'une variable
-   Vérifier le type d'une affectation
-   Choses commentées dans le `switch`

Bien faire attention à ce qu'on ait que des expression dans les `switch`. On ne doit pas faire de `fillWith` sur la partie gauche d'une affectation (par exemple).

## 3. Travail à faire

**Alexis.**

-   Revoir `SEQ` : il peut y avoir zéro expressions dans un tel nœud
-   Revoir `CALL`: il y a un itérateur dans les namespace
-   Contrôles sémantiques `ARR` , `REC`
-   Écrire et tester ses tests

**Philippe**.

-   Contrôles sémantiques `FIELD`, `ITEM` (faire attention aux `a.b.c.d` et aux `a[b][c][d]`
-   Écrire et tester ses tests

**David.**

-   Contrôle sémantique : inférence des types lors de la déclaration d'une variable (`case var` dans le `fillWithLet`)
-   `case :=`
-   `case ID`
-   Écrire et tester ses tests

**Tristan.**

-   Mettre-à-jour la suite de tests
-   Corriger le compte du nombre d'erreurs
-   Mettre-à-jour le fichier des contrôles sémantique
-   Vérifier que l'on affecte pas l'indice d'une boucle dans une boucle
-   Contrôles sémantiques sur `while` et `if else`
-   `nil`
-   Écrire et tester ses tests
