# Tutorat 2

## 1. Antlr

Retour sur les règles de priorités. Les symboles les moins prioritaires apparaissent *en haut* de l'arbre. Pour faire l'AST, on va mettre à chaque fin de ligne

```antlr
-> ^(+ idf idf)
```

En somme :

1.  Grammaire (ANTLR)
1.  AST
1.  Parcours de la table des symboles et contrôle sémantique
1.  Parcours avec génération de code et verbalisation des erreurs

Une fois que l'AST a été faites, on ne revient pas en arrière. Il vaut mieux anticiper l'AST avant. Absolument utiliser antlrworks pour faire des arbres.

## 2. Code Java

Penser à faire les contrôles sémantiques avec des exceptions.

Il est possible de tout faire dans un fichier java (non recommandé). Dans le fichier Main.java, on aura un `export AST`.

Penser à écrire des tests. Commencer par les `print`. Il permet de plus facilement voir si les codes fonctionnent.

Faire des tests les plus petits possibles. Tout ce qui est entre crochets dans ANTLR ne doit pas être fait.

## 3. AST

Mettre un chapeau derrière un terminal (ie `'+'^`) ne peut être utilisé que pour les opérateurs binaires.

Utile.

```antlr
plus: a=exp '+' b=exp -> ^(+ $a $b)
```

Est équivalent à

```antlr
plus: exp '+'^ exp
```

On peut même écrire :

```antlr
plus: a=exp ('+'^ exp)*
```

Dans ce cas, s'il n'y a qu'une expression, on n'aura pas de nœud parent '+', on aura directement l'expression.
